---
id: 599d15309e88c813a40baf58
title: Entropia
challengeType: 5
forumTopicId: 302254
dashedName: entropy
---

# --description--

Calcule a entropia H de de uma string de entrada fornecida.

Dada a variável aleatória discreta $X$, que é uma string de "símbolos" $N$ (total de caracteres) que consiste em $n$ caracteres diferentes (n=2 para binário), a entropia de Shannon de X em bits/símbolo é:

$H_2(X) = -\\sum\_{i=1}^n \\frac{count_i}{N} \\log_2 \\left(\\frac{count_i}{N}\\right)$

onde $count_i$ é a contagem de caracteres $n_i$.

# --hints--

`entropy` deve ser uma função.

```js
assert(typeof entropy === 'function');
```

`entropy("0")` deve retornar `0`

```js
assert.equal(entropy('0'), 0);
```

`entropy("01")` deve retornar `1`

```js
assert.equal(entropy('01'), 1);
```

`entropy("0123")` deve retornar `2`

```js
assert.equal(entropy('0123'), 2);
```

`entropy("01234567")` deve retornar `3`

```js
assert.equal(entropy('01234567'), 3);
```

`entropy("0123456789abcdef")` deve retornar `4`

```js
assert.equal(entropy('0123456789abcdef'), 4);
```

`entropy("1223334444")` deve retornar `1.8464393446710154`

```js
assert.equal(entropy('1223334444'), 1.8464393446710154);
```

# --seed--

## --seed-contents--

```js
function entropy(s) {

}
```

# --solutions--

```js
function entropy(s) {
    // Create a dictionary of character frequencies and iterate over it.
  function process(s, evaluator) {
    let h = Object.create(null),
      k;
    s.split('').forEach(c => {
      h[c] && h[c]++ || (h[c] = 1); });
    if (evaluator) for (k in h) evaluator(k, h[k]);
    return h;
  }
    // Measure the entropy of a string in bits per symbol.

  let sum = 0,
    len = s.length;
  process(s, (k, f) => {
    const p = f / len;
    sum -= p * Math.log(p) / Math.log(2);
  });
  return sum;
}
```
