### Sono nuovo in GitHub e nel mondo Open Source. Da dove dovrei iniziare?

Leggi la nostra guida ["Come contribuire all'Open Source"](https://github.com/freeCodeCamp/how-to-contribute-to-open-source). E' un compendio completo per progetti adatti a neofiti. Ed essa include un sacco di consigli per contribuire all'open source.

### Posso tradurre le risorse di freeCodeCamp?

Sì, puoi contribuire a ognuna delle oltre 30 lingue abilitate sulla nostra piattaforma di traduzione.

We have user-contributed translations live in some languages. Abbiamo intenzione di localizzare freeCodeCamp nelle lingue più usate nel mondo. Puoi leggere tutto su questo argomento nel nostro [annuncio](https://www.freecodecamp.org/news/world-language-translation-effort).

Se sei interessato a contribuire alla traduzione per favore assicurati di [leggere questa guida](how-to-translate-files.md) come prima cosa.

### Come posso segnalare un nuovo bug?

Se pensi di avere trovato un bug, prima leggi l'articolo ["Help I've Found a Bug" (Aiuto ho trovato un bug)](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) e segui le istruzioni.

Se sei certo che sia un nuovo bug, vai avanti e crea una issue su GitHub. Assicurati di includere quante più informazioni possibili in modo che sia possibile riprodurre il bug. Abbiamo un template predefinito per quando si crea un'issue per aiutarti in questo.

Per favore nota che queste issue in GitHub sono per problemi e discussioni sulla codebase, non per chiedere aiuto mentre impari a programmare. Se hai dubbi, dovresti [chiedere assistenza sul forum](https://forum.freecodecamp.org) prima di creare un'issue su GitHub.

### Come posso segnalare un problema di sicurezza?

Per favore non creare issue su GitHub per problemi di sicurezza. Invece invia una email a `security@freecodecamp.org` e controlleremo immediatamente.

### Io sono uno studente. Posso lavorare su una caratteristica ottenendo crediti accademici?

Sì. Per favore nota che non siamo in grado di impegnarci in alcun modo per limiti di tempo o questioni burocratiche che possono essere richiesti dal tuo college o dalla tua università. We receive many pull-requests and code contributions from volunteer developers, and we respect their time and efforts. Per rispetto di tutti gli altri nostri contributori, non daremo ad alcuna PR priorità speciale solo perché è legata a impegni accademici.

Ti chiediamo di pianificare in anticipo e lavorare sui contributi al codice tenendolo a mente.

### Cosa significano queste diverse etichette che vengono associate ai problemi?

I manutentori del codice [smistano](https://en.wikipedia.org/wiki/Software_bug#Bug_management) issue e pull request a seconda della loro priorità, gravità e altri fattori. Puoi trovare [un glossario dei loro significati qui.](https://github.com/freecodecamp/freecodecamp/labels).

### Da dove comincio se voglio lavorare su un problema?

Dovresti guardare le issue taggate con [**`help wanted`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22help+wanted%22) o [**`first timers only`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22first+timers+only%22) per una veloce overview di cosa è disponibile per lavorarci su.

> [!TIP] Le issue **`help wanted`** sono a disposizione, e non devi chiedere permessi per poterci lavorare. Tuttavia, le issue con l'etichetta **`first timers only`** sono problemi speciali che sono stati progettati per le persone che non hanno contribuito al codice freeCodeCamp prima d'ora.

### Ho trovato un errore di ortografia. Dovrei creare un'issue prima di poter fare una pull request?

Per errori di ortografia e altre modifiche di parole, puoi aprire direttamente una pull request senza prima creare un'issue. Per favore assicurati di scrivere dettagli nella descrizione della pull request per aiutarci a capire e rivedere il tuo contributo, anche se è un piccolo cambiamento.

Per favore crea un'issue se vuoi discutere aspetti più ampi del codebase o del curriculum.

### Come posso farmi assegnare un'issue?

In genere non assegnamo issue se non a contributori esperti. Invece, seguiamo la seguente politica per essere giusti nei confronti di tutti:

1. Abbiamo maggiori probabilità di fare il merge della prima pull request che affronta il problema.
2. Nel caso di più contributori che aprono una pull request per lo stesso problema all'incirca allo stesso tempo, daremo la priorità alla pull request che affronta al meglio la questione. Alcune delle cose che consideriamo:
   - Hai incluso dei test?
   - Hai coperto tutti i casi d'uso?
   - Ti sei assicurato che tutti i test siano superati, e confermi che tutto funziona localmente?
3. Infine, diamo la priorità alle pull request che seguono le nostre linee guida raccomandate.
   - Hai seguito la checklist delle pull request?
   - Hai dato alla tua pull request un titolo significativo?

### Sono bloccato su qualcosa che non è incluso in questa documentazione.

**Se hai bisogno chiedi liberamente aiuto in:**

- La categoria `Contributors` del [forum della nostra community](https://forum.freecodecamp.org/c/contributors).
- Il canale `#Contributors` sul nostro [chat server](https://chat.freecodecamp.org/channel/contributors).

Siamo entusiasti di aiutarti a contribuire in ognuno degli ambiti su cui vorresti lavorare. Se fai domande sul relativo thread di un'issue, saremo lieti di rispondere. Assicurati di fare una ricerca per la tua domanda prima di porne una nuova.

Ti ringraziamo in anticipo per essere educato e paziente. Ricordati che questa comunità è gestita principalmente da volontari.

### Assistenza aggiuntiva

Se hai domande sul nostro stack, sull'architettura del codebase, traduzioni, o qualsiasi altra cosa, rivolgiti liberamente al nostro staff.

| Staff                 | Invia un messaggio nel Forum                                                 |
|:--------------------- |:---------------------------------------------------------------------------- |
| Ahmad Abdolsaheb      | [@abdolsa](https://forum.freecodecamp.org/u/abdolsa)                         |
| Kristofer Koishigawa  | [@scissorsneedfoodtoo](https://forum.freecodecamp.org/u/scissorsneedfoodtoo) |
| Miya Liu              | [@miyaliu](https://chinese.freecodecamp.org/forum/u/miyaliu)                 |
| Mrugesh Mohapatra     | [@raisedadead](https://forum.freecodecamp.org/u/raisedadead)                 |
| Nicholas Carrigan     | [@nhcarrigan](https://forum.freecodecamp.org/u/nhcarrigan)                   |
| Oliver Eyton-Williams | [@ojeytonwilliams](https://forum.freecodecamp.org/u/ojeytonwilliams)         |
| Rafael D Hernandez    | [@RafaelHernandez](https://forum.freecodecamp.org/u/rafaelhernandez)         |
| Shaun Hamilton        | [@sky020](https://forum.freecodecamp.org/u/sky020)                           |
| Tom Mondloc           | [@moT01](https://forum.freecodecamp.org/u/moT01)                             |

**Puoi scrivere una mail allo staff di sviluppo a: `dev[at]freecodecamp.org`**
